<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-show-controls="isShowControls"
    @submit="onSubmitHandler"
    @close="onFormClose"
    :is-active-element="formData.isActive"
    @change-active="onChangeActive"
  >
    <ob-tabs
      @on-change-tab="onChangeTab"
      :items="tabsItems"
      v-model="selectedTab"
    >
      <ob-tabs-pane
        :title="dictionaryRu.modal.basic_info"
      >
        <h3 class="param-title">
          Наименование и направление деятельности
        </h3>
        <div class="row">
          <div class="col-xs-6">
            <ob-input
              v-model="formData.title"
              autocomplete="off"
              :disabled="!isNew"
              :label="dictionaryRu.modal.denomination"
              :placeholder="dictionaryRu.modal.denomination_placeholder"
              type="text"
              property="title"
              :required="true"
            />
          </div>
          <div class="col-xs-6">
            <ob-selector
              :placeholder="dictionaryRu.modal.activity_name_placeholder"
              :label="dictionaryRu.modal.activity_name"
              v-model="formData.activityUuid"
              :disabled="!isNew"
              :remote-opt="api.general.getActivities"
              property="activity.uuid"
              value-exp="uuid"
              display-exp="denomination"
              :required="true"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-3">
            <h3 class="param-title required">
              {{ dictionaryRu.modal.service_geography }}
            </h3>
            <ob-radio
                v-for="item in SERVICE_GEOGRAPHY_OPTIONS"
                :key="item.value"
                :label="item.text"
                :valueInput="item.value"
                v-model="formData.geography"
                :disabled="!isNew"
                name="status_model"
                data-qa="status_model"
                class="param-item"
            />
          </div>
          <div class="col-xs-3">
            <h3 class="param-title required">
              Категория услуг
            </h3>
            <ob-radio
                v-for="item in SERVICE_CATEGORY"
                :key="item.value"
                :label="item.text"
                :valueInput="item.value"
                v-model="formData.category"
                :disabled="!isNew"
                name="status_model"
                data-qa="status_model"
                class="param-item"
            />
          </div>
          <div class="col-xs-3">
            <h3 class="param-title required">
              {{ dictionaryRu.modal.resources_model }}
            </h3>
            <ob-radio
              v-for="item in RESOURCES_OPTIONS"
              :key="item.text"
              :label="item.text"
              :valueInput="item.value"
              v-model="formData.needResources"
              :disabled="!isNew"
              name="resources_model"
              data-qa="resources_model"
              class="param-item"
            />
          </div>
          <div class="col-xs-3">
            <h3 class="param-title required">
              {{ dictionaryRu.modal.status_model }}
            </h3>
            <ob-radio
                v-for="item in STATUS_MODEL_OPTIONS"
                :key="item.value"
                :label="item.text"
                :valueInput="item.value"
                v-model="formData.statusModel"
                :disabled="!isNew"
                name="status_model"
                data-qa="status_model"
                class="param-item"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-6">
            <h3 class="param-title">
              Дополнительно
            </h3>
              <ob-checkbox
                  v-model="formData.includedInMainService"
                  :label="dictionaryRu.modal.includedInMainService"
                  property="includedInMainService"
                  class="param-item ob-input-container"
              />
            <div class="ob-input-container exception">
              <ob-checkbox
                  v-model="formData.isIncludedInTariff"
                  :label="dictionaryRu.modal.isIncludedInTariff"
                  property="isIncludedInTariff"
              />
            </div>
            <div class="ob-input-container exception">
              <ob-checkbox
                  v-model="formData.calculateInBaseprice"
                  :label="dictionaryRu.modal.isCalculateInBaseprice"
                  property="calculateInBaseprise"
              />
            </div>
            <div class="ob-input-container">
              <ob-checkbox
                  v-model="formData.isVatCharged"
                  property="isVatCharged"
                  :label="dictionaryRu.modal.isVatCharged"
              />
            </div>
            <div class="ob-input-container">
              <ob-checkbox
                v-model="formData.needBeruchersCreation"
                :label="dictionaryRu.modal.beruchers_creation"
                property="needBeruchersCreation"
              />
            </div>
            <div class="ob-input-container exception">
              <ob-checkbox
                  v-model="formData.needTamProcessing"
                  :label="dictionaryRu.modal.TAM_processing"
                  property="needTamProcessing"
              />
            </div>
          </div>
          <div class="col-xs-6">
            <h3 class="param-title required">
              Управление включением в черновик
            </h3>
              <ob-radio
                v-for="item in INCLUSION_OPTIONS"
                :key="item.value"
                :label="item.text"
                :valueInput="item.value"
                :disabled="formData.needResources"
                v-model="formData.inclusionInDraft"
                name="inclusion_model"
                data-qa="inclusion_model"
                class="param-item"
              />
              <div class="modality" v-if="!formData.needResources">
                <h3 class="param-title required">
                  Подходящие классы ресурсов
                </h3>
                <div class="modality__options">
                  <ob-checkbox
                    v-model="formData.resourceClassCodes"
                    value="AUTO"
                    label="Целые машины"
                    property="resourceClassCodes"
                  />
                  <ob-checkbox
                    v-model="formData.resourceClassCodes"
                    value="TRAIN"
                    label="Вагоны"
                    property="resourceClassCodes"
                  />
                  <ob-checkbox
                    v-model="formData.resourceClassCodes"
                    value="CONTAINER"
                    label="Контейнеры"
                    property="resourceClassCodes"
                  />
                </div>
              </div>
          </div>
        </div>
      </ob-tabs-pane>
      <ob-tabs-pane title="ЕТСНГ">
        <ob-selector
          ref="etsng"
          v-model="formData.etsngs"
          :remote-opt="{
            method: getCargoCodes,
          }"
          :details-remote="{
            method: getCargoCode
          }"
          label="ЕТСНГ"
          placeholder="Введите код и наименование груза"
          icon="plus"
          isDropdown
          isAutoComplete
          displayExp="denomination"
          valueExp="uuid"
          data-qa="etsng"
        />
      </ob-tabs-pane>
      <ob-tabs-pane
        :title="dictionaryRu.modal.resources"
      >
        <ob-selector
          :label="dictionaryRu.modal.resource_species"
          v-model="formData.resourceSpecies"
          :placeholder="dictionaryRu.modal.resource_species_placeholder"
          display-exp="name"
          value-exp="uuid"
          :remote-opt="api.resources.getResourceSpecies"
          :details-remote="{
              method: getResourceItem
            }"
          :value="formData.resourceSpecies"
          :is-multiselect="true"
          :is-dropdown="true"
          :is-tagbox="true"
          :is-auto-complete="true"
          :disabled="!isNew"
          required
          property="resource_species"
        />
      </ob-tabs-pane>
    </ob-tabs>
  </ob-form>
</template>

<script>
import {
  STATUS_MODEL_OPTIONS,
  SERVICE_GEOGRAPHY_OPTIONS,
  SERVICE_CATEGORY,
  RESOURCES_MODEL,
  RESOURCES_OPTIONS,
  INCLUSION_OPTIONS
} from '@/resources/enum';
import {
  generateFormData,
  getValueFromPath
} from 'common-components/src/helpers/common';

import api                 from '@/api';
import cloneDeep           from 'clone-deep';
import models              from '@/models';
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import ObForm              from 'common-components/src/obComponents/obForm';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObSelector          from 'common-components/src/obComponents/obSelect';
import ObCheckbox          from './checkBox';
import ObTabs              from 'common-components/src/obComponents/obTabs/index.vue';
import ObTabsPane          from 'common-components/src/obComponents/obTabs/ObTabsPane.vue';
import ObRadio             from 'common-components/src/obComponents/obRadio'
import { dictionary } from '@/translations/ru/dictionaries__services__service_types';

export default {
  name: 'ServiceType',
  components: {
    ObCheckbox,
    ObForm,
    ObInput,
    ObSelector,
    ObTabs,
    ObTabsPane,
    ObRadio,
  },
  mixins: [FormValidationMixin],
  props: {
    dataSource: {
      type: Object,
      default: () => {}
    },
    activites: {
      type: Array,
      required: true,
      default: () => []
    },
    isShowControls: {
      type: Boolean,
      default: true
    }
  },
  async mounted() {
    // TODO убрать констатнку 100
    try {
      const res = await api.general.getDocuments(false, 0, 100, '');
      this.docTypes = res.data.content;
    } catch (e) {
      console.error(e);
      this.$notification({
        type: 'system_notification_error',
        message: 'Ошибка загрузки данных'
      });
    }
  },
  data() {
    return {
      STATUS_MODEL_OPTIONS,
      SERVICE_GEOGRAPHY_OPTIONS,
      SERVICE_CATEGORY,
      RESOURCES_MODEL,
      RESOURCES_OPTIONS,
      INCLUSION_OPTIONS,
      api: api,
      docTypes: [],
      selectedTab: {
        title: 'Основная информация',
        id: 1
      },
      viewInfo: true,
      dictionaryRu: dictionary
    };
  },
  watch: {
    'formData.title'(val) {
      this.$emit('title-changed', val);
    },
    'formData.needResources'(val) {
      if (val) {
        this.formData.inclusionInDraft = "REQUIRED_AND_ON"
      }
    }
  },
  computed: {
    tabsItems() {
      return [
        {title: 'Основная информация', id: 1},
        {title: 'ЕТСНГ', id: 2},
        ...(this.formData.needResources ? [{title: 'Ресурсы', id: 3}] : [] ),
      ];
    },
    isNew() {
      return !this.formData.uuid;
    },
    formModel() {
      return models.serviceType.add;
    },
    dropdownMenu() {
      return this.isNew || this.dataSource.deleted_at
        ? null
        : [{
            title: 'Удалить',
            className: 'color-error',
            method: () => {
              this.$emit('delete');
            }
          }];
    }
  },
  methods: {
    onFormClose() {
      this.selectedTab = {
        title: 'Основная информация',
        id: 1
      }
    },
    async getResourceItem() {
      await this.$nextTick();
      try {
        const res = await api.resources.getResourceItem(this.formData.resourceSpecies);
        return res.map(item => ({name: item.name, uuid: item.uuid}));
      } catch (err) {
        console.error(err);
      }
    },
    onChangeActive() {
      this.formData.isActive = !this.formData.isActive;
    },
    removeDoc(uuid) {
      this.formData.documents = this.formData.documents.filter(doc => {
        return doc.uuid !== uuid;
      });
    },
    addNewDoc() {
      const newDoc = generateFormData({
        model: getValueFromPath({
          data: this.formModel,
          path: 'documents.validator.$each',
          processEach: false
        })
      });

      this.formData.documents.push(cloneDeep(newDoc));
    },
    selectedResource(data) {
      let _resourceSpecies = this.formData.resourceSpecies.find(item => {
        return item.uuid === data.uuid;
      });
      if (!_resourceSpecies) {
        this.formData.resourceSpecies.push(data);
      }

      this.$refs.addResources.close();
    },
    async getCargoCode() {
      try {
        await this.$nextTick();
        const extra = await api.orders.getCargoCode({uuids: this.formData.etsngs});
        const temp = extra.values.map(item => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.title}`,
            uuid: item.uuid
          }
        })

        return temp;
      } catch(e) {
          console.error(e);
        }
    },
    async getCargoCodes({ page, size, query }) {
      try {
        const res = await api.orders.getCargoCodes({ page, size, query });
        res.content = res.content.map((item) => {
          return {
            code: item.code,
            denomination: `${item.code} ${item.denomination}`,
            uuid: item.uuid,
          };
        });
        return res;
      } catch (e) {
        console.error(e);
      }
    },
    onSubmitHandler() {
      const data = cloneDeep(this.formData);

      this.$emit('submit', {
        formData: data,
        model: this.formModel
      });
    },
    onChangeTab(tab) {
      this.selectedTab = tab;
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.info {
  background: rgba($color-green-light, 0.05);
  display: flex;
  justify-content: space-between;
  align-self: center;
  padding: 16px 20px 16px 20px;
  margin-top: 40px;
  margin-bottom: 36px;
  align-items: center;

  & > i {
    @include font-mixin(24px, 24px, normal, $color-blue-navy-blue, 0.4px);
  }
  & > .flat-type-type.ob-button-container {
    color: $color-blue-navy-blue;
  }

  & > .text {
    width: 80%;
  }
}
.flat-type-type {
  &.ob-button-container {
    color: $color-grey-border;
  }
}
.exception {
  color: #191E32;
  font-size: 14px;
  font-weight: normal;
  line-height: 16px;
  letter-spacing: 0.2px;
  display: flex;
  align-items: center;
  div ~ span {
    margin-left: 5px;
  }
}
.param-title {
  padding-top: 40px;

  & + .param-item {
    padding-top: 19px;
  }
  &.required:after {
    color: red;
    content: '*';
  }

}
.param-item {
  & + .param-item {
    padding-top: 6px;
  }
}

.modality__options {
  margin-top: 19px;
  display: flex;

  .ob-checkbox-container:not(:last-child) {
    margin-right: 30px;
  }
}

.ob-input-container + .ob-input-container {
  margin-top: 8px;
}
</style>
